import re
import time
import os
import sys
if len(sys.argv) > 0:
    outfilename = "csvs/" + sys.argv[1] + ".csv"
else:
    outfilename = "csvs/out.csv"

def process_headers (headerType, data):
    out = {}
    if headerType == "ns3::PppHeader":
        ndata = data.replace("(","").replace(")","")
        da = ndata.split(":")
        k = ""
        for e in da:
            if k == "":
                k = e
            else:
                out[k] = e
                k = ""

    if headerType == "ns3::Ipv4Header":
        ndata = data.replace(' (','(').replace(' [',' [').replace(' > ',' src dst ')[1:][:-1].replace(' ','!')
        da = ndata.split('!')
        k = ""
        for e in da:
            if k == "":
                k = e
            else:
                if e == 'src':
                    out[e] = k
                else:
                    out[k] = e
                k = ""
        #out = ndata
    if headerType == "ns3::TcpHeader":
        ndata = data.replace('(',' (').replace(')',') ').replace('=',' ').replace(' [',' k [').replace(' > ',' src dst ')[1:][:-1].replace(' ','!')
        da = ndata.split('!')
        k = ""
        for e in da:
            if k == "":
                k = e
            else:
                if e == 'src':
                    out[e] = k
                else:
                    out[k] = e
                k = ""
    return out



def do_process(line):
    b1_open = 0
    b2_open = 0
    out = ""
    for c in line:
        if c == "(":
            b1_open = b1_open + 1

        if c == ")":
            b1_open = b1_open - 1

        if c == " " and b1_open == 0:
            out = out + "\n"
        else:
            out = out + c
    #processnew string
    out_dict = {}
    out_list = out.split("\n")
    k = 0
    k_flag = 0
    key = ""
    for member in out_list:
        k = k +1
        if member.startswith("ns3"):
            k_flag = 1
            key = member
        elif k_flag == 1 and key != "":
            out_dict[key] = process_headers(key,member)
            k_flag = 0
            key = ""
        else:
            out_dict["key"+str(k)] = member
    out_dict
    return out_dict


def do_process2(lno,line):
    count = 0
    # Strips the newline character

    b1_open = 0  # (
    b2_open = 0  # [

    l = 0;
    main_dict = {};

    #for line in Lines:
      #  l = l + 1

    data = do_process(line)
    main_dict['line_' + str(l)] = data
    #print(main_dict)

    # print(main_dict)
    f = open("out.json", "a")
    f.write(str(main_dict))
    f.close()
    fline = ""
    eventid = 0
    other = "None"
    for key in main_dict:
        eventid = lno
        event = main_dict[key]['key1'] if 'key1' in main_dict[key] else other
        time = main_dict[key]['key2'] if 'key2' in main_dict[key] else other
        node = main_dict[key]['key3'].split("/")[2] if 'key3' in main_dict[key] else other
        device = main_dict[key]['key3'].split("/")[4] if 'key3' in main_dict[key] else other

        if 'ns3::Ipv4Header' in main_dict[key]:
            ip_src = main_dict[key]['ns3::Ipv4Header']['src']
            ip_dst = main_dict[key]['ns3::Ipv4Header']['dst']
            ip_len = main_dict[key]['ns3::Ipv4Header']['length:']
            ip_id = main_dict[key]['ns3::Ipv4Header']['id']
        else:
            ip_src = "-1"
            ip_dst = "-1"
            ip_len = "-1"
            ip_id = "-1"

        if 'ns3::TcpHeader' in main_dict[key]:
            tcp_src_port = main_dict[key]['ns3::TcpHeader']['src'][1:]
            tcp_dst_port = main_dict[key]['ns3::TcpHeader']['dst']
            tcp_seq = main_dict[key]['ns3::TcpHeader']['Seq']
            tcp_ack = main_dict[key]['ns3::TcpHeader']['Ack']
        else:
            tcp_dst_port = "-1"
            tcp_dst_port = "-1"
            tcp_seq = "-1"
            tcp_ack = "-1"


        fline = fline + str(
            eventid) + "," + event + "," + time + "," + node + "," + device + "," + ip_id + "," + ip_src + "," + ip_dst + "," + ip_len + "," + tcp_src_port + "," + tcp_dst_port + "," + tcp_seq + "," +tcp_ack + "\n"
        print(eventid)
        if eventid > 10000:
            break

    f = open(outfilename, "a")
    f.write(str(fline))
    f.close()





def follow(name):
    current = open(name, "r")
    curino = os.fstat(current.fileno()).st_ino
    while True:
        while True:
            line = current.readline()
            if not line:
                break
            yield line

        try:
            if os.stat(name).st_ino != curino:
                new = open(name, "r")
                current.close()
                current = new
                curino = os.fstat(current.fileno()).st_ino
                continue
        except IOError:
            pass
        time.sleep(1)


#clear exsiting data
f = open("out.json", "w")
f.write("")
f.close()

f = open(outfilename, "w")
f.write("eventid,event,time,node,device,ip_id,ip_src,ip_dst,ip_len,tcp_src_port,tcp_dst_port,tcp_seq,tcp_ack" + "\n")
f.close()


fname = "../ps1.tr"

if os.path.isfile(fname):
    print("File Exsits")
else:
    f = open(fname, "w")
    f.write("")
    f.close()
no = 0
for l in follow(fname):
    no = no + 1
    print("LINE: {}".format(l))
    do_process2(no,l)
    #if no > 2:
     #   break;



