#Title : Erlang Learner
#Author : Arif Husen, <arifhrashid@gmail.com>,<arif.husen@vu.edu.pk>
#COMSATS University Isalamabad, Lahore Campus
#Date: 27 March, 2023

import pandas as pd
from numpy import array
from numpy import hstack
from keras.models import Sequential
from keras.layers import LSTM
from keras.layers import Dense
from keras.layers import RepeatVector
from keras.layers import TimeDistributed


# Fetch Data  from network nodes
cols = ['node', 'time', 'kpbs', 'pkt_size', 'period', 'packets', 'gnode', 'vbytes']

df = pd.DataFrame(columns=cols)

file1 = open('traffic.csv', 'r')
Lines = file1.readlines()

node = -1
for line in Lines:
    node += 1
    nodedata_arr = line.split(",")
    for node_item in nodedata_arr:
        trffic_data_arr = node_item.split('|')
        time = trffic_data_arr[0]
        kpbs = trffic_data_arr[1].replace('Kbps', '')
        pkt_size = trffic_data_arr[2]
        period = trffic_data_arr[3]
        gnode = 1 + (node // 4)
        packets = (int(period) * int(kpbs) * 1024 / 8) // int(pkt_size)
        vbytes = (int(period) * int(kpbs) * 1024 / 8)
        df.loc[len(df.index)] = [node, time, kpbs, pkt_size, period, packets, gnode, vbytes]
# df

##############Node-1#########################################################################
dfg1 = df[df['node'] == 0]
N = 100
dfn = pd.DataFrame(columns=cols)
for i in range(0, N):
    dfn.loc[len(dfn.index)] = ["0", str(i), "0", "0", "0", "0", "0", "0"]
df_cd = pd.merge(dfn, dfg1, how='left', on='time')

df_cd['node'] = df_cd['node_x']
df_cd['kpbs'] = df_cd['kpbs_y']
df_cd['pkt_size'] = df_cd['pkt_size_y']
df_cd['period'] = df_cd['period_y']
df_cd['packets'] = df_cd['packets_y']
df_cd['gnode'] = df_cd['gnode_y']
df_cd['vbytes'] = df_cd['vbytes_y']
dfdf1 = df_cd[cols].fillna(0)
for i in range(0, N):
    p = dfdf1.iloc[i, 4]  # period
    if int(p) > 1:
        node = dfdf1.iloc[i, 0]
        kbps = dfdf1.iloc[i, 2]
        pkt_size = dfdf1.iloc[i, 3]
        period = 1
        packets = int(dfdf1.iloc[i, 5]) / int(p)
        gnode = dfdf1.iloc[i, 6]
        vbytes = dfdf1.iloc[i, 7]
        for n in range(i, i + int(p) + 1):
            if n < N:
                dfdf1.at[n, 'node'] = node;
                dfdf1.at[n, 'kpbs'] = kbps;
                dfdf1.at[n, 'pkt_size'] = pkt_size;
                dfdf1.at[n, 'period'] = period;
                dfdf1.at[n, 'packets'] = packets;
                dfdf1.at[n, 'gnode'] = gnode;
                dfdf1.at[n, 'vbytes'] = int(vbytes) / int(p);

dn1 = dfdf1.copy()
dn1s = dn1[['time', 'vbytes']]
dn1s['vbytes'] = dn1s['vbytes'] / 1000
t1 = dn1s[dn1s['time'].astype(int) < 51]

##############Node-2#########################################################################

dfg1 = df[df['node'] == 1]
dfn = pd.DataFrame(columns=cols)
for i in range(0, N):
    dfn.loc[len(dfn.index)] = ["1", str(i), "0", "0", "0", "0", "0", "0"]
df_cd = pd.merge(dfn, dfg1, how='left', on='time')

df_cd['node'] = df_cd['node_x']
df_cd['kpbs'] = df_cd['kpbs_y']
df_cd['pkt_size'] = df_cd['pkt_size_y']
df_cd['period'] = df_cd['period_y']
df_cd['packets'] = df_cd['packets_y']
df_cd['gnode'] = df_cd['gnode_y']
df_cd['vbytes'] = df_cd['vbytes_y']
dfdf1 = df_cd[cols].fillna(0)
for i in range(0, N):
    p = dfdf1.iloc[i, 4]  # period
    if int(p) > 1:
        node = dfdf1.iloc[i, 0]
        kbps = dfdf1.iloc[i, 2]
        pkt_size = dfdf1.iloc[i, 3]
        period = 1
        packets = int(dfdf1.iloc[i, 5]) / int(p)
        gnode = dfdf1.iloc[i, 6]
        vbytes = dfdf1.iloc[i, 7]
        for n in range(i, i + int(p) + 1):
            if n < N:
                dfdf1.at[n, 'node'] = node;
                dfdf1.at[n, 'kpbs'] = kbps;
                dfdf1.at[n, 'pkt_size'] = pkt_size;
                dfdf1.at[n, 'period'] = period;
                dfdf1.at[n, 'packets'] = packets;
                dfdf1.at[n, 'gnode'] = gnode;
                dfdf1.at[n, 'vbytes'] = int(vbytes) / int(p);

dn2 = dfdf1.copy()
dn2s = dn2[['time', 'vbytes']]
dn2s['vbytes'] = dn2s['vbytes'] / 1000
t2 = dn2s[dn2s['time'].astype(int) < 51]
# t2

##############Node-3#########################################################################
dfg1 = df[df['node'] == 2]
dfn = pd.DataFrame(columns=cols)
for i in range(0, N):
    dfn.loc[len(dfn.index)] = ["2", str(i), "0", "0", "0", "0", "0", "0"]
df_cd = pd.merge(dfn, dfg1, how='left', on='time')

df_cd['node'] = df_cd['node_x']
df_cd['kpbs'] = df_cd['kpbs_y']
df_cd['pkt_size'] = df_cd['pkt_size_y']
df_cd['period'] = df_cd['period_y']
df_cd['packets'] = df_cd['packets_y']
df_cd['gnode'] = df_cd['gnode_y']
df_cd['vbytes'] = df_cd['vbytes_y']
dfdf1 = df_cd[cols].fillna(0)
for i in range(0, N):
    p = dfdf1.iloc[i, 4]  # period
    if int(p) > 1:
        node = dfdf1.iloc[i, 0]
        kbps = dfdf1.iloc[i, 2]
        pkt_size = dfdf1.iloc[i, 3]
        period = 1
        packets = int(dfdf1.iloc[i, 5]) / int(p)
        gnode = dfdf1.iloc[i, 6]
        vbytes = dfdf1.iloc[i, 7]
        for n in range(i, i + int(p) + 1):
            if n < N:
                dfdf1.at[n, 'node'] = node;
                dfdf1.at[n, 'kpbs'] = kbps;
                dfdf1.at[n, 'pkt_size'] = pkt_size;
                dfdf1.at[n, 'period'] = period;
                dfdf1.at[n, 'packets'] = packets;
                dfdf1.at[n, 'gnode'] = gnode;
                dfdf1.at[n, 'vbytes'] = int(vbytes) / int(p);

dn3 = dfdf1.copy()
dn3s = dn3[['time', 'vbytes']]
dn3s['vbytes'] = dn3s['vbytes'] / 1000
t3 = dn3s[dn3s['time'].astype(int) < 51]
# t3

##############Node-4#########################################################################

dfg1 = df[df['node'] == 3]
dfn = pd.DataFrame(columns=cols)
for i in range(0, N):
    dfn.loc[len(dfn.index)] = ["3", str(i), "0", "0", "0", "0", "0", "0"]
df_cd = pd.merge(dfn, dfg1, how='left', on='time')

df_cd['node'] = df_cd['node_x']
df_cd['kpbs'] = df_cd['kpbs_y']
df_cd['pkt_size'] = df_cd['pkt_size_y']
df_cd['period'] = df_cd['period_y']
df_cd['packets'] = df_cd['packets_y']
df_cd['gnode'] = df_cd['gnode_y']
df_cd['vbytes'] = df_cd['vbytes_y']
dfdf1 = df_cd[cols].fillna(0)
for i in range(0, N):
    p = dfdf1.iloc[i, 4]  # period
    if int(p) > 1:
        node = dfdf1.iloc[i, 0]
        kbps = dfdf1.iloc[i, 2]
        pkt_size = dfdf1.iloc[i, 3]
        period = 1
        packets = int(dfdf1.iloc[i, 5]) / int(p)
        gnode = dfdf1.iloc[i, 6]
        vbytes = dfdf1.iloc[i, 7]
        for n in range(i, i + int(p) + 1):
            if n < N:
                dfdf1.at[n, 'node'] = node;
                dfdf1.at[n, 'kpbs'] = kbps;
                dfdf1.at[n, 'pkt_size'] = pkt_size;
                dfdf1.at[n, 'period'] = period;
                dfdf1.at[n, 'packets'] = packets;
                dfdf1.at[n, 'gnode'] = gnode;
                dfdf1.at[n, 'vbytes'] = int(vbytes) / int(p);

dn4 = dfdf1.copy()
dn4s = dn4[['time', 'vbytes']]
dn4s['vbytes'] = dn4s['vbytes'] / 1000
t4 = dn4s[dn4s['time'].astype(int) < 51]

in_seq4 = t4['vbytes'].to_numpy()


########################End of Data Fetching################################################


#++++++++++++++++++ML model+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

def preproceesor1(dataSeq, inSteps, outSteps):
    X = list()
    y = list()
    for i in range(len(dataSeq)):
        # First we determine the end index of in and out of X values , break if the dataset is not matching 
        # the indexes and finally construct input and ouput pattern**********
        eox_i = i + inSteps
        eox_io = eox_i + outSteps
        if eox_io > len(dataSeq):
            break
        seq_x, seq_y = dataSeq[i:eox_i, :], dataSeq[eox_i:eox_io, :]
        X.append(seq_x)
        y.append(seq_y)
    return array(X), array(y)


# Loading the node data fecthed earlier
idata_n1 = t1['vbytes'].to_numpy()
idata_n2 = t2['vbytes'].to_numpy()
idata_n3 = t3['vbytes'].to_numpy()
idata_n4 = t4['vbytes'].to_numpy()

cdata_n1 = array([idata_n1[i] + idata_n2[i] + idata_n3[i] + idata_n4[i] for i in range(len(idata_n1))])


# Arrangin data in in tabular format
idata_n1 = idata_n1.reshape((len(idata_n1), 1))
idata_n2 = idata_n2.reshape((len(idata_n2), 1))
idata_n3 = idata_n3.reshape((len(idata_n3), 1))
idata_n4 = idata_n4.reshape((len(idata_n4), 1))

cdata_n1 = cdata_n1.reshape((len(cdata_n1), 1))

# We need to stack columns horizantly
dataset = hstack((idata_n1, idata_n2, idata_n3, idata_n4, cdata_n1))

# Define the in and out steps
inSteps, outSteps = 3, 3

# using proscess to covert into input/output
X, y = preproceesor1(dataset, inSteps, outSteps)

nf = X.shape[2] #total number of features, just consider the Erlang Values

# Configuring LSTM 
opt = 'adam'
los = 'mse'
act = 'relu'
m = Sequential()
m.add(LSTM(200, activation=act, input_shape=(inSteps, nf)))
m.add(RepeatVector(outSteps))
m.add(LSTM(200, activation=act, return_sequences=True))
m.add(TimeDistributed(Dense(nf)))
m.compile(optimizer=opt, loss=los) # use adam and mean square as opimizer and loss
m.fit(X, y, epochs=300, verbose=0)

#get the predictions
pi = 48 #intial step

x_input = array([[idata_n1[pi], idata_n2[pi], idata_n3[pi], idata_n4[pi], cdata_n1[pi]],
                 [idata_n1[pi + 1], idata_n2[pi + 1], idata_n3[pi + 1], idata_n4[pi + 1], cdata_n1[pi + 1]],
                 [idata_n1[pi + 2], idata_n2[pi + 2], idata_n3[pi + 2], idata_n4[pi + 2], cdata_n1[pi + 2]]])


x_input = x_input.reshape((1, inSteps, nf))
pvalues = m.predict(x_input, verbose=0) # predcited values

#transfor the data to shape suitable for TIPS. TIP reads the data in formate <timeStamp, AggregationNode, numPhy, Erlranks(|), Erlweights(|)>
node = "g1"
ir = 500 / 8 # the Datarate of Phy from Access to aggregation Node,
R = [0, 0, 0]   # holder for ranks of interface Erlngs values
W = [0, 0, 0]   # holder for weights of Erlan Values
for y in pvalues:
    n = 0
    for z in y:
        arr = z[0:4]
        ones = all(el == 1 for el in arr)
        if (ones == True):
            ranks = [4, 4, 4, 4]
        else:
            ranks = [sorted(arr, reverse=True).index(x) + 1 for x in arr]
        R[n] = ranks
        ws = [int(x / ir) + 1 for x in arr]     #convert to Erlang  values , datarate * period / PhyRate * period
        W[n] = ws
        n = n + 1

out = ""
L = 0
node = "g1"

for t in range(pi + 3, pi + 3 + 3): # append data for predcited times
    r = ""
    for i in R[L]:
        r = r + str(i) + "|"
    r = r[:-1] + ","
    for i in W[L]:
        r = r + str(i) + "|"
    r = r[:-1]
    r = str(t) + "," + node + "," + str(len(R[L])) + "," + r
    out = out + r + "\n"
    L = L + 1

#Final Save the data for TIPS usage
file = open('g1ml.txt', 'a')  # Open a file in append mode
file.write(out)  # Write some text
file.close()  # Close the file
#print(out)