/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
/*
 * Authors:  Arif Husen <arifhrashid@gmail.com>
 *           COMSATS University Islamabad, Lahore Campus
 */
#ifndef TIPS_H
#define TIPS_H
#include <iostream>
#include <string>
#include <fstream>
#include <vector>
#include <algorithm>
#include <sstream>
#include <ostream>
#include <map>
#include <iterator>
#include "ns3/queue-disc.h"
using namespace ns3;
namespace ns3 {
class TipsQueueDisc : public QueueDisc {
public:
  static TypeId GetTypeId (void);
 TipsQueueDisc ();
  std::string tips_NodeID;
  int get_erlang(std::string t,std::string n,std::string s,int i);
  int get_weight(std::string t,std::string n,std::string s,int i);
  int get_sources(std::string t,std::string n);
    std::string get_sources_str(std::string t,std::string n);
  bool detect_change(std::string t);
  virtual ~TipsQueueDisc();
  static constexpr const char* LIMIT_EXCEEDED_DROP = "Queue disc limit exceeded";
private:
  int prio2band[5] = {0,1,2,3,4};
  uint32_t erlOrder[16];
  bool update_erlOrder(std::string ts);
    std::vector<int> take_int(std::string str);
  int load_learner_output();
  virtual bool DoEnqueue (Ptr<QueueDiscItem> item);
  virtual Ptr<QueueDiscItem> DoDequeue (void);
  virtual Ptr<const QueueDiscItem> DoPeek (void);
  virtual bool CheckConfig (void);
  virtual void InitializeParams (void);
  std::map<std::string, /*time*/
  std::map<std::string, /*node*/
  std::map<std::string, /*queues*/
  std::map<int,int> /*int,erlang*/
  >>>m_erlang_profiles;
  std::map<std::string, /*time*/
  std::map<std::string, /*node*/
  std::map<std::string, /*queues*/
  std::map<int,int> /*int,erlang*/
  >>>m_erlang_weights;
};
}
#endif /* TIPS_H */